* $$ JOB JNM=SAMCLINT,CLASS=A,DISP=D                                            
* $$ LST CLASS=F,DEST=(,AFTPDRS)                                                
// JOB SAMCLINT                                                                 
// OPTION CATAL                                                                 
// LIBDEF *,SEARCH=(DRSLIB.TCPIP13K,PRD1.MACLIB,PRD2.GEN1,             X        
               IJSYSRS.SYSLIB)                                                  
// LIBDEF *,CATALOG=DRSLIB.TEST                                                 
*                                                                               
* * EXECUTING ASSEMBLY OF SAMPLE CLIENT PROGRAM...                              
// EXEC ASMA90,SIZE=ASMA90,PARM='SZ(MAX-200K,ABOVE)'                            
         PUNCH '  PHASE SAMCLINT,*'                                             
SAMCLINT CSECT                                                                  
SAMCLINT RMODE 24                                                               
SAMCLINT AMODE 31                                                               
         USING SAMCLINT,R15        ESTABLISH TEMPORARY ADDRESSABILITY           
         B     MAIN1000            LETS GET TO WORK                             
*                                                                               
* * THIS IS A SAMPLE TCP CLIENT APPLICATION THAT USES                           
* * THE SOCKETS API FOR ASSEBLER. IT WILL:                                      
* * OPEN A CONNECTION TO THE SAMPLE SERVER APPLICATION                          
* * READ COMMANDS FROM THE VSE CARD READER                                      
* * DISPLAY THE COMMAND ONTO SYSLOG AND SYSLST                                  
* * SEND THE COMMAND TO THE SERVER APPLICATION                                  
* * ISSUE A RECEIVE AND WAIT FOR A REPLY FROM THE SERVER                        
* * DISPLAY THE REPLY ONTO SYSLOG AND SYSLST                                    
* * AFTER ALL CARDS HAVE BEEN READ IT WILL                                      
* * CLOSE THE CONNECTION AND TERMINATE                                          
*                                                                               
MAINNAME DC    CL8'SAMCLINT'                                                    
COMVERS  DC    CL8'01.00.00'       VERSION AND RELEASE                          
COMADATE DC    CL8'&SYSDATC'       ASSEMBLED DATE                               
COMATIME DC    CL8'&SYSTIME'       ASSEMBLED TIME                               
         SOCKET ID=00,MF=L         SOCKET GLOBAL CONTANTS                       
         DROP     ,                                                             
*                                                                               
*                                                                               
* * THE PROGRAM MAINLINE LOGIC STARTS HERE...                                   
* * WE SHOULD BE ENTERED IN 31-BIT MODE AND WILL GO INTO 24-BIT                 
* * MODE ONLY WHEN USING A SERVICE THAT REQUIRES 24-BIT MODE...                 
MAIN1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R12,R15             SET 1ST BASE REGISTER                        
         LA    R9,2048(,R12)       SET 2ND BASE REG                             
         LA    R9,2048(,R9)        "                                            
         USING SAMCLINT,R12,R9     ESTABLISH BASE REGISTERS                     
         ST    R13,MAINSAVE+4      STORE CALLERS R13                            
         LA    R13,MAINSAVE        PROVIDE SAVEAREA                             
         AMODESW SET,AMODE=24      SWITCH TO 24 BIT MODE FOR OPENS              
         OPEN  CONSOLE,LISTING,CARDIN                                           
         AMODESW SET,AMODE=31      SWITCH BACK TO 31-BIT MODE                   
*                                                                               
* * OPEN A ACTIVE CONNECTION TO THE SERVER...                                   
         SOCKET   OPEN,TCP,                                            X        
               ACTIVE=YES,         GO GET IT NOW                       X        
               FOPORT=SERVPORT,    THIS IS THE SERVERS PORT ADDRESS    X        
               FOIP=SERVIPAD,      THIS IS THE SERVERS IP ADDRESS      X        
               DESC=CLNTOKEN,      SOCKET DESCRIPTOR(1 FWORD)          X        
               MFG=SOPAREA,        BUILD PARAMETER LIST HERE           X        
               USESYS=YES,         USE SYSID FROM // OPTION SYSPARM='XX'        
               CICS=NO,                                                X        
               WAIT=YES,                                               X        
               ECB=RSLTAREA        SOCKET RESULTS AREA 56 BYTES                 
         LTR   R15,R15             DID IT WORK?                                 
         BZ    MAIN2000            BIF YES                                      
         BAL   R1,MAIN7000         ERROR EXIT                                   
         DC    C'SRVOFAIL'                                                      
MAIN2000 DS    0H                                                               
         LA    R4,RSLTAREA         @ OF RESULTS AREA                            
         USING SRBLOK,R4                                                        
         LA    R1,SRECB            @ OF THE ECB                                 
         WAIT  (1)                                                              
         CLI   SRCODE,SROPGOOD     WAS IT GOOD ?                                
         BE    MAIN3000            BIF YES                                      
         SLR   R15,R15             CLEAR REG                                    
         IC    R15,SRCODE          PUT IT HERE                                  
         BAL   R1,MAIN7000         ERROR EXIT                                   
         DC    C'OPENFAIL'                                                      
MAIN3000 DS    0H                                                               
*        BAL   R2,TRACEIT                                                       
*        DC    CL8'MAIN3000'                                                    
         AMODESW SET,AMODE=24                                                   
         GET   CARDIN              GET A COMMAND FROM SYSIPT                    
         AMODESW SET,AMODE=31                                                   
         LA    R0,L'CARDAREA                                                    
         LA    R1,CARDAREA                                                      
         L     R15,@CONORTN        ECHO THE CARD ONTO SYSLOG + SYSLST           
         BASSM R14,R15                                                          
         MVC   SNDBUFF,CARDAREA    MOVE COMMAND INTO THE SEND BUFFER            
         MVI   SNDBUFF+72,X'15'    END OF COMMAND                               
*                                                                               
* * NOW SEND THE CARD TO THE SAMPLE SERVER                                      
         SOCKET   SEND,TCP,                                            X        
               DATA=(@SNDBUFF,SNDBUFFL),                               X        
               DESC=CLNTOKEN,                                          X        
               MFG=SOPAREA,        BUILD PARAMETER LIST HERE           X        
               ECB=RSLTAREA                                                     
         LTR   R15,R15             DID TCP/IP ACCEPT THE BUFFER ?               
         BZ    MAIN3400            BIF YES                                      
         BAL   R1,MAIN7000         ERROR EXIT                                   
         DC    C'SENDFAIL'                                                      
MAIN3400 DS    0H                                                               
         LA    R1,SRECB            @ OF ECB                                     
         WAIT  (1)                                                              
         CLI   SRCODE,SROPGOOD                                                  
         BE    MAIN3500                                                         
         BAL   R1,MAIN7000         ERROR EXIT                                   
SENDWFAL DC    C'SENDWFAL'                                                      
MAIN3500 DS    0H                                                               
         LA    R0,L'REPLY          MAXIMUM REPLY AREA                           
         LA    R1,REPLY            BUILD THE REPLY HERE                         
         L     R15,@RSTREAM        @ OF THE STREAM READ ROUTINE                 
         BASSM R14,R15                                                          
         LTR   R15,R15             DID WE GET A REPLY ?                         
         BZ    MAIN4000            BIF YES                                      
         BAL   R1,MAIN7000         ERROR EXIT                                   
         DC    C'BADREPLY'                                                      
MAIN4000 DS    0H                                                               
         L     R15,@CONORTN        ECHO THE REPLY ONTO SYSLOG + SYSLST          
         BASSM R14,R15                                                          
         B     MAIN3000            GO AND GET THE NEXT CARD...                  
*                                                                               
* * ALL OUT OF CARDS SO LETS CLOSE THE CONNECTION...                            
MAIN6000 DS    0H                                                               
         AMODESW SET,AMODE=31                                                   
*                                                                               
* * LETS CLOSE THE CONNECTION...                                                
         SOCKET   CLOSE,TCP,                                           X        
               DESC=CLNTOKEN,                                          X        
               MFG=SOPAREA,        BUILD PARAMETER LIST HERE           X        
               ECB=RSLTAREA                                                     
         LTR   R15,R15             DID IT WORK?                                 
         BZ    MAIN6200            BIF YES                                      
         BAL   R1,MAIN7000         ERROR EXIT                                   
CLOSFAIL DC    C'CLOSFAIL'                                                      
MAIN6200 DS    0H                                                               
         LA    R1,SRECB            @ OF ECB                                     
         WAIT  (1)                                                              
         CLI   SRCODE,SRCLGOOD     DID IT CLOSE CLEAN ?                         
         BE    MAIN6400            BIF YES                                      
         CLI   SRCODE,SRCLNFND     DID THE SERVER CLOSE IT ?                    
         BE    MAIN6400            BIF YES                                      
         IC    R15,SRCODE          PASS THE RETURN CODE                         
         BAL   R1,MAIN7000         ERROR EXIT                                   
CLOSWFAL DC    C'CLOSWFAL'                                                      
MAIN6400 DS    0H                                                               
         LA    R15,0               RETURN CODE IS ZERO                          
         ST    R15,RETCODE         STORE THE RETURN CODE                        
         B     MAIN9000            ALL DONE                                     
*                                                                               
MAIN7000 DS    0H                                                               
         LTR   R15,R15             WAS A RETURN CODE PASSED                     
         BNZ   MAIN7200            BIF YES                                      
         LA    R15,8               SET BAD RETURN CODE                          
MAIN7200 DS    0H                                                               
         ST    R15,RETCODE         STORE IT                                     
         MVC   IERRRESN,0(R1)      ERROR MESSAGE REASON                         
         LA    R0,IERRMSGL         ERROR MESSAGE LENGTH                         
         LA    R1,IERRMSG          ERROR MESSAGE TEXT                           
         L     R15,@CONORTN                                                     
         BASSM R14,R15             WRITE ERROR REASON                           
         B     MAIN9000            EXIT                                         
*                                                                               
MAIN9000 DS    0H                                                               
*                                                                               
* * THE FOLLOWING IS THE SAME AS DOING AN EOJ MACRO...                          
         L     R15,RETCODE         RETURN CODE                                  
         L     R13,MAINSAVE+4      RESTORE JOB CONTROLS R13                     
         LM    R0,R12,20(R13)      RESTORE R0-R12                               
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
*                                                                               
* *                                                                             
TRACEIT  DS    0H                                                               
         LA    R0,8                                                             
         LTR   R1,R2               @ OF TRACE INFO                              
         L     R15,@CONORTN                                                     
         BASSM R14,R15                                                          
         B     8(R2)               RETURN                                       
*                                                                               
MAINSAVE DS    9D                                                               
DWORK    DS    D                                                                
FWORK    DS    F                                                                
@CONORTN DC    A(CONO1000)         CONSOLE OUTPUT ROUTINE                       
@PUTLRTN DC    A(PUTL1000)                                                      
@RSTREAM DC    A(RSTR1000)         TCP STREAM PROCESSOR                         
RECBUFFL DC    F'80'                                                            
@RECBUFF DC    A(RECBUFF)                                                       
SNDBUFFL DC    F'80'                                                            
@SNDBUFF DC    A(SNDBUFF)                                                       
@SAMCLNT DS    A                   @ OF SAMCLINT                                
CLNTOKEN DS    F                   SOCKET DESCRIPTOR TOKEN                      
RSLTAREA DS    14F                                                              
SERVIPAD DC    AL1(192),AL1(168),AL1(3),AL1(1)                                  
SERVPORT DC    H'5453'             PORT TO BE USED                              
RETCODE  DC    F'99'                                                            
SNDBUFF  DS    CL80                                                             
RECBUFF  DS    CL80                                                             
REPLY    DS    CL80                                                             
HEXWORK  DS    XL9                 HEX WORK AREA                                
SOPAREA  DS    0F,(SOPLEN)X        PARAMETER AREA                               
*                                                                               
IERRMSG  DS    0H                                                               
         DC    C'Critical Error Occurred Reason='                               
IERRRESN DC    CL8'XXXXXXXX'                                                    
IERRMSGL EQU   *-IERRMSG                                                        
*                                                                               
LISTING  DTFDI DEVADDR=SYSLST,             DEFINE A PRINTER            *        
               IOAREA1=LINEOUT,            OUTPUT LINE                 *        
               RECSIZE=121                 LENGTH OF RECORD                     
LINEOUT  DS    CL121                                                            
*                                                                               
CARDIN   DTFDI IOAREA1=CARDAREA,                                       *        
               DEVADDR=SYSRDR,                                         *        
               RECSIZE=80,                                             *        
               EOFADDR=MAIN6000                                                 
CARDAREA DS    CL80                                                             
*                                                                               
CONSOLE  DTFCN DEVADDR=SYSLOG,             CONSOLE DEVICE ADDRESS      *        
               IOAREA1=CONOUT,             I/O AREA BUFFERS OUT+IN     *        
               RECFORM=FIXUNB,             FIXED UNBLOCKED             *        
               BLKSIZE=64,                 OUTPUT AREA SIZE            *        
               INPSIZE=64,                 INPUT AREA SIZE             *        
               TYPEFLE=CMBND               COMBINED INPUT/OUTPUT                
CONOUT   DS    CL64                        OUTPUT BUFFER AREA                   
*                                                                               
         LTORG ,                                                                
*                                                                               
* * THE FOLLOWING ROUNDS OFF TO 8K                                              
BIGWORK  DS    XL((8192)-(*-SAMCLINT))                                          
BIGWORKL EQU   *-BIGWORK                                                        
         DROP  ,                                                                
*                                                                               
* * GET A REPLY BY READING TCP STREAM...                                        
* * R0 = REPLY LENGTH                                                           
* * R1 = REPLY TEXT                                                             
         USING SAMCLINT,R12,R9     ESTABLISH SAMCLINT ADDRESSABILITY            
         DC    CL8'RSTR1000'                                                    
RSTR1000 DS    0H                                                               
*                                                                               
* It is fundamentally important to understand the concept of streams            
* when programming with TCP.                                                    
* TCP may choose to break a block of data into pieces and transmit              
* each piece in a separate segement or it may choose to accumulate              
* data in its buffer before sending a segment(fully fill a datagram)            
* As a result the receiving application may receive data in small               
* chunks, even if the sending application passed it to TCP in a                 
* single send.                                                                  
* Or, the receiving application may receive a large chunk                       
* even if the sending application passes it to TCP in multiple send             
* requests.                                                                     
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15                                                          
         USING RSTR1000,R11                                                     
         ST    R13,RSTRSAVE+4                                                   
         LA    R13,RSTRSAVE                                                     
         LTR   R5,R1               BUILD RELPLY FROM STREAM HERE                
         LTR   R6,R0               MAX THAT CAN FIT IN A COMMAND                
         ST    R5,RSTRCADR         STORE PASSED ADDRESS OF AREA TO FILL         
         ST    R6,RSTRCLNG         STORE PASSED LENGTH                          
*                                                                               
* * GET A TELNET RECORD FOR THE CALLER                                          
* * RECORD MEANS GET A STREAM AND SCAN UNTIL WE GET A END OF LINE...            
         ICM   R3,15,RSTRWADR      DO WE HAVE A STREAM POINTER?                 
         BZ    RSTR1800            BIF NO GET SOME DATA                         
         L     R1,@RECBUFF         START OF STREAM                              
         L     R2,RSTRWLNG         LENGTH OF STREAM                             
         LA    R4,0(R2,R1)         END OF STREAM                                
         SLR   R4,R3               CALCULATE LENGTH LEFT                        
         B     RSTR3400            PICK UP HERE...                              
RSTR1800 DS    0H                                                               
         SOCKET   RECEIVE,TCP,                                         X        
               DATA=(@RECBUFF,RECBUFFL),                               X        
               DESC=CLNTOKEN,                                          X        
               ECB=RSLTAREA                                                     
         LTR   R15,R15             DID IT WORK?                                 
         BZ    RSTR2000            BIF YES                                      
         BAL   R1,RSTR9000                                                      
BADRECV1 DC    C'BADRECV1'                                                      
RSTR2000 DS    0H                                                               
         LA    R1,RSLTAREA         ADDRESS THE ECB                              
         WAIT  (1)                                                              
         USING SRBLOK,R1                                                        
         CLI   SRCODE,SRREGOOD     WAS IT CLEAN?                                
         BE    RSTR2800            BIF YES                                      
         BAL   R1,RSTR9000                                                      
BADRECV2 DC    C'BADRECV2'                                                      
RSTR2800 DS    0H                                                               
         LH    R0,SRCOUNT          BYTES READ                                   
         LTR   R4,R0               DID WE GET ANY?                              
         BP    RSTR3000            BIF YES                                      
         BAL   R1,RSTR9000                                                      
BADRECV3 DC    C'BADRECV3'                                                      
         DROP  R1                                                               
RSTR3000 DS    0H                                                               
         ST    R4,RSTRWLNG         STORE THE LENGTH RECEIVED                    
         L     R3,@RECBUFF         START ADDRESS OF DATA RECEIVED               
         ST    R3,RSTRWADR         STORE THE NEW POINTER                        
RSTR3400 DS    0H                                                               
         CLI   0(R3),X'15'         IS THIS A EBCIDIC NEW LINE ?                 
         BE    RSTR7000            BIF YES                                      
         MVC   0(1,R5),0(R3)       MOVE A BYTE INTO BUFFER                      
         LA    R3,1(,R3)           BUMP TO NEXT IN STREAM                       
         LA    R5,1(,R5)           BUMP TO NEXT IN COMMAND                      
         BCT   R4,RSTR4000         IF NOT ZERO GOTO RSTR4000                    
         B     RSTR1800            DO A RECEIVE FOR MORE OF STREAM              
*                                                                               
* *                                                                             
RSTR4000 DS    0H                                                               
         BCT   R6,RSTR3400         DO IT AGAIN                                  
*                                                                               
* * IF WE FALL THRU THE ABOVE BCT THAN WE HAVE SCANNED FOR 80                   
* * BYTES AND HAVE NOT HIT A END OF LINE CHARACTER...                           
         BAL   R1,RSTR9000                                                      
         DC    CL8'REPNOEOL'                                                    
RSTR7000 DS    0H                                                               
         LA    R3,1(,R3)           BUMP PAST END OF LINE                        
         BCT   R4,RSTR8000                                                      
         SLR   R3,R3               NO MORE DATA IN STREAM                       
RSTR8000 DS    0H                                                               
         ST    R3,RSTRWADR         STORE UPDATED POINTER INTO STREAM            
         L     R1,RSTRCADR         R1 = ADDRESS OF THE COMMAND                  
         LR    R0,R5               R0 = RECORD LENGTH                           
         SR    R0,R1               CALCULATE THE RECORD LENGTH                  
         LA    R15,0               RC = GOOD                                    
RSTR9000 DS    0H                                                               
         L     R13,RSTRSAVE+4                                                   
         LM    R2,R12,28(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BR    R14                 RETURN TO CALLER                             
         LTORG ,                                                                
RSTRSAVE DS    9D                                                               
RSTRCLNG DS    F                                                                
RSTRCADR DS    F                                                                
RSTRWLNG DS    F                                                                
RSTRWADR DS    F                                                                
         DROP  ,                                                                
*                                                                               
* * R0 = MESSAGE LENGTH                                                         
* * R1 = MESSAGE TEXT                                                           
         USING SAMCLINT,R12,R9     ESTABLISH SAMCLINT ADDRESSABILITY            
         DC    CL8'PUTL1000'                                                    
PUTL1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15             GET A BASE REGISTER                          
         USING PUTL1000,R11                                                     
         ST    R13,PUTLSAVE+4      STORE CALLERS R13                            
         LA    R13,PUTLSAVE        PROVIDE SAVEAREA                             
         LR    R4,R0               MESSAGE LENGTH                               
         LR    R5,R1               MESSAGE TEXT                                 
         MVI   LINEOUT,X'40'       CLEAR I/O AREA                               
         MVC   LINEOUT+1(L'LINEOUT-1),LINEOUT PROPOGATE THE BLANK               
         LR    R2,R4               MESSAGE LENGTH                               
         BCTR  R2,0                MINUS 1 FOR THE EXECUTE                      
         EX    R2,PUTLMVC                                                       
         AMODESW SET,AMODE=24                                                   
         PUT   LISTING                                                          
         AMODESW SET,AMODE=31                                                   
PUTL9000 DS    0H                                                               
         LA    R15,0               RETURN CODE                                  
         L     R13,PUTLSAVE+4      RESTORE CALLERS R13                          
         LM    R0,R12,20(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
PUTLMVC  MVC   LINEOUT+1(0),0(R5)  EXECUTED INSTRUCTION                         
PUTLSAVE DS    18F                                                              
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
* * R0 = MESSAGE LENGTH                                                         
* * R1 = MESSAGE TEXT                                                           
         USING SAMCLINT,R12,R9     ESTABLISH SAMCLINT ADDRESSABILITY            
         DC    CL8'CONO1000'                                                    
CONO1000 DS    0H                                                               
         STM   R14,R12,12(R13)     SAVE REGS                                    
         LR    R11,R15             GET A BASE REGISTER                          
         USING CONO1000,R11                                                     
         LR    R4,R0               MESSAGE LENGTH                               
         LR    R5,R1               MESSAGE TEXT                                 
         ST    R13,CONOSAVE+4      STORE CALLERS R13                            
         LA    R13,CONOSAVE        PROVIDE SAVEAREA                             
         MVI   CONOUT,X'40'        CLEAR I/O AREA                               
         MVC   CONOUT+1(L'CONOUT-1),CONOUT PROPOGATE THE BLANK                  
         LTR   R2,R4               IS THE MESSAGE LENGTH ZERO                   
         BNZ   CONO2000            PUT OUT INVALID MESSAGE MESSAGE              
         LA    R0,L'CONOBAD1                                                    
         LA    R1,CONOBAD1         PUT OUT THIS MESSAGE                         
CONO2000 DS    0H                                                               
         LA    R0,L'CONOUT                                                      
         CLR   R2,R0               IS IT TOO BIG                                
         BL    CONO3000            BIF NO                                       
         LR    R2,R0               USE THE MAX                                  
CONO3000 DS    0H                                                               
         BCTR  R2,0                MINUS 1 FOR THE EXECUTE                      
         EX    R2,CONOMVC                                                       
         AMODESW SET,AMODE=24                                                   
         PUT   CONSOLE                                                          
         WAIT  CONSOLE                                                          
         AMODESW SET,AMODE=31                                                   
         LA    R0,L'CONOUT                                                      
         LA    R1,CONOUT                                                        
         L     R15,@PUTLRTN        DISPLAY ONTO SYSLST TOO                      
         BASSM R14,R15                                                          
CONO9000 DS    0H                                                               
         LA    R15,0               RETURN CODE                                  
         L     R13,CONOSAVE+4      RESTORE CALLERS R13                          
         LM    R0,R12,20(R13)      RESTORE CALLERS R0-R12                       
         L     R14,12(R13)         RESTORE R14                                  
         BSM   0,R14               RETURN TO CALLER IN CALLED MODE              
CONOMVC  MVC   CONOUT(0),0(R5)     EXECUTED INSTRUCTION                         
CONOBAD1 DC    C'CONOBAD1'                                                      
CONOSAVE DS    18F                                                              
         LTORG ,                                                                
         DROP  ,                                                                
*                                                                               
*                                                                               
* * EQUATES...                                                                  
R0       EQU      0                                                             
R1       EQU      1                                                             
R2       EQU      2                                                             
R3       EQU      3                                                             
R4       EQU      4                                                             
R5       EQU      5                                                             
R6       EQU      6                                                             
R7       EQU      7                                                             
R8       EQU      8                                                             
R9       EQU      9                                                             
R10      EQU      10                                                            
R11      EQU      11                                                            
R12      EQU      12                                                            
R13      EQU      13                                                            
R14      EQU      14                                                            
R15      EQU      15                                                            
         END      SAMCLINT                                                      
/*                                                                              
*                                                                               
* * EXECUTING LINK EDIT TO CREATE SAMCLINT PHASE...                             
// EXEC LNKEDT,SIZE=512K                                                        
/*                                                                              
// OPTION SYSPARM='00'  TCP/IP PARTITION SYSTEM IDENTIFER                       
// LIBDEF PHASE,SEARCH=DRSLIB.TEST                                              
*                                                                               
* * EXECUTING SAMPLE CLIENT PROGRAM...                                          
// EXEC SAMCLINT,SIZE=SAMCLINT  TRACE                                           
HARTBEAT                                                                        
/*                                                                              
/&                                                                              
* $$ EOJ                                                                        
